/* mu_sval - get the string contents for a STRING_VAL field
 * Assumes cursor is just to right of string
 */
#include "menu.h"
SCR_CMDCHAR mu_sval(psv)
	STRING_VAL *psv;	/* ptr to the STRING_VAL structure : str_sync  */
						/* str_sync = screen agrees with contents of   */
						/*            psv->string                      */
	{
	char *s;			/* ptr to start of string */
	short i;			/* index of current nul-terminator */
	SCR_CMDCHAR c;		/* latest SCR_CMDCHAR returned from scr_getkey */

	s = psv->string;
	i = strlen(s);
	FOREVER
		{
		c = scr_getkey();
		if (SCR_CMD(c))				/* if c is a command character, */
			return (c);				/* return it */
		else if (c == '\b')
			{
			if (i > 0)
				{
				scr_print("\b \b");	/* erase previous character */
				s[--i] = '\0';		/* shorten the string */
				}
			}
		else if (psv->edit_type == 'n' && !isdigit(c) &&
			!(i == 0 && c == '-'))
			{
			scr_beep();				/* non-digit invalid */
			}
		else if (i < psv->maxsize - 1)
			{
			scr_putc(s[i++] = c);	/* append the char, and echo it */
			s[i] = '\0';
			}
		else
			scr_beep();				/* no room left in string */
		}
	}
